# This file should contain all the record creation needed to seed the database with its default values.
# The data can then be loaded with the rails db:seed command (or created alongside the database with db:setup).
#
# Examples:
#
#   movies = Movie.create([{ name: 'Star Wars' }, { name: 'Lord of the Rings' }])
#   Character.create(name: 'Luke', movie: movies.first)
Course.delete_all

Course.create!([{'core': true, 'code': '501', 'course_name': 'Operating Systems Principles', 'description': 'Fundamental issues related to the design of operating systems. Process scheduling and coordination, deadlock, memory management and elements of distributed systems.', 'syllabus_id': '1', 'channel_id': '1'},
  {'core': true, 'code': '503', 'course_name': 'Computational Applied Logic', 'description': 'Introduction to the conceptual and formal apparatus of mathematical logic, to mathematical concepts underlying the process of logical formalization, and to the applications of various logics across a broad spectrum of problems in computer science and artificial intelligence.', 'syllabus_id': '2', 'channel_id': '2'},
  {'core': true, 'code': '505', 'course_name': 'Design and Analysis Of Algorithms', 'description': 'Algorithm design techniques: use of data structures, divide and conquer, dynamic programming, greedy techniques, local and global search. Complexity and analysis of algorithms: asymptotic analysis, worst case and average case, recurrences, lower bounds, NP-completeness. Algorithms for classical problems including sorting, searching and graph problems [connectivity, shortest paths, minimum spanning trees].', 'syllabus_id': '3', 'channel_id': '3'},
  {'core': true, 'code': '506', 'course_name': 'Architecture Of Parallel Computers', 'description': 'The need for parallel and massively parallel computers. Taxonomy of parallel computer architecture, and programming models for parallel architectures. Example parallel algorithms. Shared-memory vs. distributed-memory architectures. Correctness and performance issues. Cache coherence and memory consistency. Bus-based and scalable directory-based multiprocessors. Interconnection-network topologies and switch design. Brief overview of advanced topics such as multiprocessor prefetching and speculative parallel execution. Credit is not allowed for more than one course in this set: ECE 406, ECE 506,  406.', 'syllabus_id': '4', 'channel_id': '4'},
  {'core': true, 'code': '510', 'course_name': 'Software Engineering', 'description': 'An introduction to software life cycle models; size estimation; cost and schedule estimation; project management; risk management; formal technical reviews; analysis, design, coding and testing methods; configuration management and change control; and software reliability estimation. Emphasis on large development projects. An individual project required following good software engineering practices throughout the semester.', 'syllabus_id': '5', 'channel_id': '5'},
  {'core': true, 'code': '512', 'course_name': 'Compiler Construction', 'description': 'Theory and practice of compiler writing. Lexical analysis, table driven LL[1], LR[1] and LALR[1] parsers, code generation, flow analysis, run-time storage organization and optimization. Writing a compiler using software tools a significant part of course.', 'syllabus_id': '6', 'channel_id': '6'}, {'core': false, 'code': '513', 'course_name': 'Electronic Commerce Technology', 'description': 'Exploration of technological issues and challenges underlying electronic commerce. Distributed systems; network infrastructures; security, trust, and payment solutions; transaction and database systems; and presentation issues. Project required. No Audits.', 'syllabus_id': '7', 'channel_id': '7'},
  {'core': false, 'code': '515', 'course_name': 'Software Security', 'description': 'Introduces students to the discipline of designing, developing, and testing secure and dependable software-based systems. Students will learn about risks and vulnerabilities, and effective software security techniques. Topics include common vulnerabilities, access control, information leakage, logging, usability, risk analysis, testing, design principles, security policies, and privacy. Project required.', 'syllabus_id': '8', 'channel_id': '8'},
  {'core': false, 'code': '517', 'course_name': 'Object-Oriented Design and Development', 'description': 'The design of object-oriented systems, using principles such as the GRASP principles, and methodologies such as CRC cards and the Unified Modeling Language [ULM]. Requirements analysis. Design patterns Agile Methods. Static vs. dynamic typing. Metaprogramming. Open-source development practices and tools. Test-first development. Project required, involving contributions to an open-source software project.', 'syllabus_id': '9', 'channel_id': '9'},
  {'core': false, 'code': '519', 'course_name': 'DevOps', 'description': 'Modern software development organizations require entire teams of DevOps to automate and maintain software engineering processes and infrastructure vital to the organization. In this course, you will gain practical exposure to the skills, tools, and knowledge needed in automating software engineering processes and infrastructure. Students will have the chance to build new or extend existing software engineering tools and design a DevOps pipeline.', 'syllabus_id': '10', 'channel_id': '10'},
  {'core': true, 'code': '520', 'course_name': 'Artificial Intelligence I', 'description': 'Introduction to and overview of artificial intelligence. Study of AI programming language such as LISP or PROLOG. Elements of AI problem-solving technique. State spaces and search techniques. Logic, theorem proving and associative databases. Introduction to knowledge representation, expert systems and selected topics including natural language processing, vision and robotics.', 'syllabus_id': '11', 'channel_id': '11'},
  {'core': false, 'code': '522', 'course_name': 'Automated Learning and Data Analysis', 'description': 'Introduction to the problems and techniques for automated discovery of knowledge in databases. Topics include representation, evaluation, and formalization of knowledge for discovery; classification, prediction, clustering, and association methods.Selected applications in commerce, security, and bioinformatics. Students cannot get credit for both  422 and  522.', 'syllabus_id': '12', 'channel_id': '12'},
  {'core': false, 'code': '530', 'course_name': 'Computational Methods for Molecular Biology', 'description': 'Computer algorithms supporting genomic research: DNA sequence comparison and assembly, hybridization mapping, phylogenetic reconstruction, genome rearrangement, protein folding and threading.', 'syllabus_id': '13', 'channel_id': '13'},
  {'core': true, 'code': '540', 'course_name': 'Database Management concepts and Systems', 'description': 'Advanced database concepts. Logical organization of databases: the entity-relationship model; the relational data model and its languages. Functional dependencies and normal forms. Design, implementation, and optimization of query languages; security and integrity, consurrency control, transaction processing, and distributed database systems.', 'syllabus_id': '14', 'channel_id': '14'}, {'core': false, 'code': '541', 'course_name': 'Advanced Data Structures', 'description': 'Complex and specialized data structures relevant to design and development of effective and efficient software. Hardware characteristics of storage media. Primary file organizations. Hashing functions and collision resolution techniques. Low level and bit level structures including signatures, superimposed coding, disjoint coding and Bloom filters. Tree and related structures including AVL trees, B*trees, tries and dynamic hashing techniques.', 'syllabus_id': '15', 'channel_id': '15'},
  {'core': false, 'code': '546', 'course_name': 'Management Decision and Control Systems', 'description': 'Planning, design, and development and implementation of comprehensive computer-based information systems to support management decisions. Formal information systems principles; information requirements analysis; knowledge acquisition techniques; information modeling. Information resource management for quality operational control and decision support; system evaluation, process improvement and cost effectiveness.', 'syllabus_id': '16', 'channel_id': '16'},
  {'core': false, 'code': '547', 'course_name': 'Cloud Computing Technology', 'description': 'Study of cloud computing principles, architectures, and actual implementations. Students will learn how to critically evaluate cloud solutions, how to construct and secure a private cloud computing environment based on open source solutions, and how to federate it with external clouds. Performance, security, cost, usability, and utility of cloud computing solutions will be studied both theoretically and in hands-on exercises. Hardware-, infrastructure-, platform-, software-, security-, and high-performance computing - "as-a-service".', 'syllabus_id': '17', 'channel_id': '17'},
  {'core': false, 'code': '548', 'course_name': 'Parallel Systems', 'description': 'Basic concepts of parallel computation; parallel programming models and algorithm design; load balancing and performance optimization; parallel I/0 and high-end storage systems; high performance parallel applications.', 'syllabus_id': '18', 'channel_id': '18'},
  {'core': false, 'code': '554', 'course_name': 'Human-Computer Interaction', 'description': 'Basic theory and concepts of human-computer interaction. Human and computational aspects. Cognitive engineering. Practical HCI skills. Significant historical case studies. Current technology and future directions in user interface development.', 'syllabus_id': '19', 'channel_id': '19'},
  {'core': false, 'code': '555', 'course_name': 'Social Computing', 'description': 'This course surveys the field of social computing, introducing its key concepts, paradigms, and techniques. Specific topics are selected from the following list: social media and social network analytics, sociological underpinnings, crowdsourcing and surveys, human computation, social mobilization, human decision making, voting theory, judgment aggregation, prediction markets, economic mechanisms, incentives, organizational modeling, argumentation, contracts, norms, mobility and social context, sociotechnical systems, and software engineering with and for social computing. This course incorporates ideas from diverse disciplines [including sociology, psychology, law, economics, political science, logic, statistics, philosophy, business] to provide essential background for future computer science careers in industry and research.', 'syllabus_id': '20', 'channel_id': '20'},
  {'core': true, 'code': '561', 'course_name': 'Principles of Computer Graphics', 'description': 'Fundamentals of the OpenGL API. 2D and 3D transformations, perspective and orthographic projection, and the mathematical foundations that underlie these concepts. Geometric primitives, clipping, depth buffering, scan conversion, and rasterization. Lighting, shadows, and texture mapping. Curves and surfaces.', 'syllabus_id': '21', 'channel_id': '21'},
  {'core': false, 'code': '562', 'course_name': 'Introduction to Game Engine Design', 'description': 'This course offers an advanced discussion of topics in computer graphics, with an emphasis on rendering techniques and GPU shader programming used in computer game engine design. Students are required to implement a medium-size game program that includes modeling and rendering, 2D physics, and animation of dynamic objects. Students will learn about GPU basics, mathematics of transformations, visual appearance properties, texturing, global illumination, and toon shading in computer games.', 'syllabus_id': '22', 'channel_id': '22'},
  {'core': false, 'code': '563', 'course_name': 'Visual Interfaces for Mobile Devices', 'description': 'The conception and creation of effective visual interfaces for mobile devices, including ideation and prototyping for useful mobile applications, the industry and architecture of mobile devices, mobile usage context, computer graphics and interfaces for mobiles, and mobile programming.', 'syllabus_id': '23', 'channel_id': '23'},
  {'core': true, 'code': '565', 'course_name': 'Graph Theory', 'description': 'Basic concepts of graph theory. Trees and forests. Vector spaces associated with a graph. Representation of graphs by binary matrices and list structures. Traversability. Connectivity. Matchings and assignment problems. Planar graphs. Colorability. Directed graphs. Applications of graph theory with emphasis on organizing problems in a form suitable for computer solution.', 'syllabus_id': '24', 'channel_id': '24'}, {'core': false, 'code': '568', 'course_name': 'Enterprise Storage Architecture', 'description': 'An introduction to storage systems architecture in an enterprise. Begins with a review of the individual components of a system [eg, hard disk drives, network interfaces], and shows how to aggregate those into storage systems. Tradeoffs involving factors such as cost, complexity, availability, power and performance. Discussion of information management strategies, including data migration. Guest lectures by representatives from local industry. Students work in teams on a semester-long project.', 'syllabus_id': '25', 'channel_id': '25'},
  {'core': true, 'code': '570', 'course_name': 'Computer Networks', 'description': 'General introduction to computer networks. Discussion of protocol principles, local area and wide area networking, OSI stack, TCP/IP and quality of service principles. Detailed discussion of topics in medium access control, error control coding, and flow control mechanisms. Introduction to networking simulation, security, wireless and optical networking.', 'syllabus_id': '26', 'channel_id': '26'},
  {'core': false, 'code': '573', 'course_name': 'Internet Protocols', 'description': 'Principles and issues underlying provision of wide area connectivity through interconnection of autonomous networks. Internet architecture and protocols today and likely evolution in future. Case studies of particular protocols to demonstrate how fundamental principles applied in practice. Selected examples of networked clinet/server applications to motivate the functional requirements of internetworking. Project required.', 'syllabus_id': '27', 'channel_id': '27'},
  {'core': false, 'code': '574', 'course_name': 'Computer and Network Security', 'description': 'Security policies, models, and mechanisms for secrecy, integrity, and availability. Basic cryptography and its applications; operating system models and mechanisms for mandatory and discretionary controls; introduction to database security; securityin distributed systems; network security [firewalls, IPsec, and SSL]; and control and prevention of viruses and other rogue programs.', 'syllabus_id': '28', 'channel_id': '28'},
  {'core': false, 'code': '575', 'course_name': 'Introduction to Wireless Networking', 'description': 'Introduction to cellular communications, wireless local area networks, ad-hoc and IP infrastructures. Topics include: cellular networks, mobility mannagement, connection admission control algorithms, mobility models, wireless IP networks, ad-hoc routing, sensor networks, quality of service, and wireless security.', 'syllabus_id': '29', 'channel_id': '29'},
  {'core': false, 'code': '576', 'course_name': 'Networking Services', 'description': 'Topics related to networking services, signaling for setting up networking services, such as SIP and IMS, networking architectures for providing QoS for networking services, such as MPLS, DiffServ and RAC, signaling protocols for setting up QoS connections in the transport stratum, such as LDP and RSVP-TE, video-based communications, and capacity planning models for dimensioning services.', 'syllabus_id': '30', 'channel_id': '30'},
  {'core': false, 'code': '577', 'course_name': 'Switched Network Management', 'description': 'Topics related to design and management of campus enterprise networks, including VLAN design; virtualization and automation methodologies for management; laboratory use of open space source and commercial tools for managing such networks.', 'syllabus_id': '31', 'channel_id': '31'},
  {'core': false, 'code': '579', 'course_name': 'Introduction to Computer Performance Modeling', 'description': 'Workload characterization, collection and analysis of performance data, instrumentation, tuning, analytic models including queuing network models and operational analysis, economic considerations.', 'syllabus_id': '32', 'channel_id': '32'},
  {'core': true, 'code': '580', 'course_name': 'Numerical Analysis I', 'description': 'Algorithm behavior and applicability. Effect of roundoff errors, systems of linear equations and direct methods, least squares via Givens and Householder transformations, stationary and Krylov iterative methods, the conjugate gradient and GMRES methods, convergence of method.', 'syllabus_id': '33', 'channel_id': '33'},
  {'core': false, 'code': '582', 'course_name': 'Computer Models of Interactive Narrative', 'description': 'A theoretical and practical study of the computational models supporting the creation of interactive narrative systems. Topics include basic introductions to cognitive, linguistic and film theoretic models of narrative; representations and reasoning techniques from artificial intelligence related to the creation of storylines, dialog, camera control and other features of narrative in text-based and/or 3D virtual worlds; mechanisms for controlling character behavior in multi-agent multi-user stories; and applications of these techniques ranging from interactive entertainment to educational software to training simulations.', 'syllabus_id': '34', 'channel_id': '34'},
  {'core': false, 'code': '583', 'course_name': 'Introduction to Parallel Computing', 'description': 'Introduction to basic parallel architectures, algorithms and programming paradigms; message passing collectives and communicators; parallel matrix products, domain decomposition with direct and iterative methods for linear systems; analysis of efficiency, complexity and errors; applications such as 2D heat and mass transfer.', 'syllabus_id': '35', 'channel_id': '35'},
  {'core': false, 'code': '584', 'course_name': 'Building Game AI', 'description': 'In this course we will examine Artificial Intelligence [AI] techniques that are used in the design of computer games. We will look at techniques for game playing as well as the design of AI opponents tasked with creating "good experiences" for players. The course will begin with a discussion of general AI, common algorithms, data structures, and representations. From there, we will cover topics in character movement, pathfinding, decision making, strategy, tactics, and learning. In a sequence of programming assignments students will create increasingly sophisticated AI implementations. Students will also critically review the projects conducted by graduate students enrolled in 584.  majors only. Students cannot get credit for both  484 and  584.', 'syllabus_id': '36', 'channel_id': '36'},
  {'core': false, 'code': '591', 'course_name': 'Special Topics In Computer Science', 'description': 'Topics of current interest in computer science not covered in existing courses.', 'syllabus_id': '37', 'channel_id': '37'},
  {'core': false, 'code': '600', 'course_name': 'Computer Science Graduate Orientation', 'description': 'Introduction for new graduate students to [a] information about graduate program, department, and university resources, and [b] research projects conducted by  faculty.', 'syllabus_id': '38', 'channel_id': '38'},
  {'core': false, 'code': '630', 'course_name': "Master's Independent Study", 'description': 'Individual investigation of topics under the direction of member[s] of the graduate faculty.', 'syllabus_id': '39', 'channel_id': '39'},
  {'core': false, 'code': '685', 'course_name': "Master's Supervised Teaching", 'description': 'Teaching experience under the mentorship of faculty who assist the student in planning for the teaching assignment, observe and provide feedback to the student during the teaching assignment, and evaluate the student upon completion of the assignment.', 'syllabus_id': '40', 'channel_id': '40'},
  {'core': false, 'code': '688', 'course_name': 'Non-Thesis Masters Continuous Registration - Half Time Registration', 'description': "For students in non-thesis master's programs who have completed all credit hour requirements for their degree but need to maintain half-time continuous registration to complete incomplete grades, projects, final master's exam, etc.", 'syllabus_id': '41', 'channel_id': '41'},
  {'core': false, 'code': '689', 'course_name': 'Non-Thesis Master Continuous Registration - Full Time Registration', 'description': "For students in non-thesis master's programs who have completed all credit hour requirements for their degree but need to maintain full-time continuous registration to complete incomplete grades, projects, final master's exam, etc. Students may register for this course a maximum of one semester.", 'syllabus_id': '42', 'channel_id': '42'},
  {'core': false, 'code': '690', 'course_name': "Master's Examination", 'description': "For students in non thesis master's programs who have completed all other requirements of the degree except preparing for and taking the final master's exam.", 'syllabus_id': '43', 'channel_id': '43'}, {'core': false, 'code': '693', 'course_name': "Master's Supervised Research", 'description': 'Instruction in research and research under the mentorship of a member of the Graduate Faculty.', 'syllabus_id': '44', 'channel_id': '44'}, {'core': false, 'code': '695', 'course_name': "Master's Thesis Research", 'description': 'Thesis research.', 'syllabus_id': '45', 'channel_id': '45'}, {'core': false, 'code': '696', 'course_name': 'Summer Thesis Research', 'description': 'For graduate students whose programs of work specify no formal course work during a summer session and who will be devoting full time to thesis research.', 'syllabus_id': '46', 'channel_id': '46'}, {'core': false, 'code': '699', 'course_name': "Master's Thesis Preparation", 'description': "For students who have completed all credit hour requirements and full-time enrollment for the master's degree and are writing and defending their thesis.", 'syllabus_id': '47', 'channel_id': '47'}, {'core': false, 'code': '705', 'course_name': 'Operating Systems Security', 'description': 'Fundamentals and advanced topics in operating system [OS] security. Study OS level mechanisms and policies in investigating and defending against real-world attacks on computer systems, such as self-propagating worms, stealthy rootkits and large-scale botnets. OS security techniques such as authentication, system call monitoring, as well as memory protection. Introduce recent advanced techniques such as system-level randomization and hardware virtualization.', 'syllabus_id': '48', 'channel_id': '48'}, {'core': false, 'code': '707', 'course_name': 'Automata, Languages and Computability Theory', 'description': 'Formal models of language and computation; finite automata and regular languages, pushdown automata and context-free languages, Turing machines. Relative power of models, Chomsky hierarchy. Inherent complexity of problems: undecidability, computational complexity, intractable problems.', 'syllabus_id': '49', 'channel_id': '49'}, {'core': false, 'code': '710', 'course_name': 'Software Engineering as a Human Activity', 'description': 'This course addresses the human aspect of software engineering, by studying the people who practice it. Students will explore software engineering as traditionally defined, and also consider techniques that transform how we understand software engineering, such as methods from psychology and sociology. Students will study the usability of software engineering tools, the psychology of programming, performance of software developers, experimental methods in observing software engineers, distributed development and coordination, and cultural differences between software developers.', 'syllabus_id': '50', 'channel_id': '50'}, {'core': false, 'code': '711', 'course_name': 'Geospatial Data Management', 'description': 'Data management principles and technologies for efficient implementation of geospatial applications. This course introduces students to: spatial and temporal data types, data models, geometry models, spatial predicates, spatial access methods, and spatial query processing. In addition, students will be exposed to modern data management systems for geospatial application development and data integration principles. Prior GIS programming knowledge and knowledge of database management systems and SQL is preferred.', 'syllabus_id': '51', 'channel_id': '51'}, {'core': false, 'code': '712', 'course_name': 'Software Testing and Reliability', 'description': 'An advanced introduction to software testing and reliability. The course is a balanced mixture of theory, practice, and application. Methods, techniques, and tools for testing software and producing reliable and secure software are used and analyzed. Software reliability growth models and techniques for improving and predicting software reliability are examined, and their practical use is demonstrated. Good knowledge of C++ or Java. Knowledge of the basics of statistics, calculus, and linear algebra.', 'syllabus_id': '52', 'channel_id': '52'}, {'core': false, 'code': '714', 'course_name': 'Real Time Computer Systems', 'description': 'Design and implementation of computer systems required to provide specific response times. Structure of a real-time kernel, fixed and dynamic priority scheduling algorithms, rate monotonic scheduling theory, priority inheritance protocols, real-timebenchmarks, case study of a real-time kernel.', 'syllabus_id': '53', 'channel_id': '53'}, {'core': false, 'code': '720', 'course_name': 'Artificial Intelligence II', 'description': 'A second course in artificial intelligence emphasizing advanced concepts of AI including logic programming, automatic programming, natural language understanding, visual perception by machine, learning and inference, intelligent computer-aided instruction, knowledge representation, robotics and other topics to be chosen by instructor. Students asked to write programs in AI programming language such as LISP and PROLOG.', 'syllabus_id': '54', 'channel_id': '54'}, {'core': false, 'code': '722', 'course_name': 'Advanced Topics in Machine Learning', 'description': 'A broad range of advanced topics in machine learning, the building of computer-based systems that can adapt to their environment and learn from their own experience. Theory of learnability, technical details of various learning methods, combination of multiple methods, evaluation of methods, and related topics [at the discretion of the instructor].', 'syllabus_id': '55', 'channel_id': '55'}, {'core': false, 'code': '724', 'course_name': 'Advanced Distributed Systems', 'description': 'Principles in the design and implementation of modern distributed systems; recent techniques used by real-world distributed systems such as peer-to-peer file sharing, enterprise data center, and internet search engines; state-of-the-art architectures, algorithms, and performance evaluation methodologies in distributed systems.', 'syllabus_id': '56', 'channel_id': '56'}, {'core': false, 'code': '742', 'course_name': 'Database Management Systems', 'description': 'Database concepts. Database design. Data models: entity-relationship and relational. Data manipulation languages including SQL. Data Dictionaries. Query processing. Concurrency. Software development environments using a database system. Expert, object-oriented, multimedia and distributed database systems. Database systems architecture. Use of a commercial database management system.', 'syllabus_id': '57', 'channel_id': '57'}, {'core': false, 'code': '743', 'course_name': 'Secure Data Management', 'description': 'Advanced topics in secure data management with techniques in traditional database management systems as well as in recent advances in emerging areas. Emphasis on new security issues and challenges imposed by the Internet and the Web on cross-organization data sharing and management. Example topics include XML, data management in P2P, trust management, data authorship, and the integration of security and privacy policies with information systems.', 'syllabus_id': '58', 'channel_id': '58'}, {'core': false, 'code': '750', 'course_name': 'Service-Oriented Computing', 'description': 'Concepts, theories, and techniques for computing with services. This course examines architectures for Web applications based on the classical publish, find, and bind triangle, but formulates it at a higher level. It considers sophisticated approaches for the description, discovery, and engagement of services, especially over the Web and the Grid. This course emphasizes service composition. Key topics include semantics, transactions, processes, agents, quality of service, compliance, and trust.', 'syllabus_id': '59', 'channel_id': '59'}, {'core': false, 'code': '761', 'course_name': 'Advanced Topics in Computer Graphics', 'description': 'Understanding and discussing current advances and research topics in computer graphics. Possible topics include nonphotorealistic rendering, modeling natural phenomena, illumination and rendering techniques, model simplification, animation, visualization, graphics hardware. Learning to critique research papers from important venues in the computer graphics field. Learning to read, interpret, and present computer graphics research papers in a conference-type environment.', 'syllabus_id': '60', 'channel_id': '60'}, {'core': false, 'code': '762', 'course_name': 'Computer Simulation Techniques', 'description': 'Basic discrete event simulation methodology: random number generators, simulation designs, validation, analysis of simulation output. Applications to various areas of scientific modeling. Simulation language such as SLAM and GPSS. Computer assignments and projects.', 'syllabus_id': '61', 'channel_id': '61'}, {'core': false, 'code': '766', 'course_name': 'Code Optimization for Scalar and Parallel Programs', 'description': 'Advanced research issues in code optimization for scalar and parallel programs; program analysis, scalar and parallel optimizations as well as various related advanced topics.', 'syllabus_id': '62', 'channel_id': '62'}, {'core': false, 'code': '772', 'course_name': 'Survivable Networks', 'description': 'Principles of network and service continuity and related metrics; the theory of network availability, survivability, and restoration; a comprehensive coverage of network architectures, protocols, algorithms, and related technology for survivability; advanced topics in network survivability; hands-on experience in the implementation of protocols and software for survivable systems and the operation of survivable networks.', 'syllabus_id': '63', 'channel_id': '63'}, {'core': false, 'code': '773', 'course_name': 'Advanced Topics in Internet Protocols', 'description': 'Cutting-edge concepts and technologies to support internetworking in general and to optimize the performance of the TCP/IP protocol suite in particular. Challenges facing and likely evolution for next generation intenetworking technologies. This course investigates topics that include, but may be not limited to: Internet traffic measurement, characteriztion and modeling, traffic engineering, network-aware applications, quality of service, peer-to-peer systems, content-distribution networks, sensor networks, reliable multicast, and congestion control.', 'syllabus_id': '64', 'channel_id': '64'}, {'core': false, 'code': '774', 'course_name': 'Advanced Network Security', 'description': 'A study of network security policies, models, and mechanisms. Topics include: network security models; review of cryptographic techniques; internet key management protocols; electronic payments protocols and systems; intrusion detection and correlation; broadcast authentication; group key management; security in mobile ad-hoc networks; security in sensor networks.', 'syllabus_id': '65', 'channel_id': '65'}, {'core': false, 'code': '775', 'course_name': 'Advanced Topics in Wireless Networking', 'description': 'Reviews the current state of research in wireless networks, network architectures, and applications of wireless technologies; students will design, organize, and implement or simulate systems in a full-semester research project. For students with background in networking and communications who wish to explore research and development topics.', 'syllabus_id': '66', 'channel_id': '66'}, {'core': false, 'code': '776', 'course_name': 'Design and Performance Evaluation of Network Systems and Services', 'description': 'Introduction to the design and performance evaluation of network services. Topics include top-down network design based on requirements, end-to-end services and network system architecture, service level agreements, quantitative performance evaluation techniques. Provides quantitative skills on network service traffic and workload modeling, as well as, service applications such as triple play, internet [IPTV], Peer-to-peer [P2P], voice over IP [VoIP], storage, network management, and access services.', 'syllabus_id': '67', 'channel_id': '67'}, {'core': false, 'code': '777', 'course_name': 'Telecommunications Network Design', 'description': 'Analytic modeling and topological design of telecommunications networks, including centralized polling networks, packet switched networks, T1 networks, concentrator location problems, routing strategies, teletraffic engineering and network reliability.', 'syllabus_id': '68', 'channel_id': '68'}, {'core': false, 'code': '780', 'course_name': 'Numerical Analysis II', 'description': 'Approximation and interpolation, Fast Fourier Transform, numerical differentiation and integration, numerical solution of initial value problems for ordinary differential equations.', 'syllabus_id': '69', 'channel_id': '69'}, {'core': false, 'code': '791', 'course_name': 'Advanced Topics In Computer Science', 'description': 'Advanced topics of current interest in computer science not covered by existing courses.', 'syllabus_id': '70', 'channel_id': '70'}, {'core': false, 'code': '801', 'course_name': 'Seminar in Computer Science', 'description': 'Faculty and graduate student research presentations and discussions centered around current research problems in Computer Science and advanced theories in these areas. Students are expected to make presentations of published works and, depending onthe course credit received and their academic degree progress, present their own research results. Critical discussions of the various research approaches and results and their relationships based on the presentations and additional readings and research. Departmental Approval Required.', 'syllabus_id': '71', 'channel_id': '71'}, {'core': false, 'code': '830', 'course_name': 'Doctoral Independent Study', 'description': 'Individual investigation of advanced topics under the direction of member[s] of the graduate faculty.', 'syllabus_id': '72', 'channel_id': '72'}, {'core': false, 'code': '885', 'course_name': 'Doctoral Supervised Teaching', 'description': 'Teaching experience under the mentorship of faculty who assist the student in planning for the teaching assignment, observe and provide feedback to the student during the teaching assignment, and evaluate the student upon completion of the assignment.', 'syllabus_id': '73', 'channel_id': '73'}, {'core': false, 'code': '890', 'course_name': 'Doctoral Preliminary Exam', 'description': 'For students who are preparing for and taking written and/or oral preliminary exams.', 'syllabus_id': '74', 'channel_id': '74'}, {'core': false, 'code': '893', 'course_name': 'Doctoral Supervised Research', 'description': 'Instruction in research and research under the mentorship of a member of the Graduate Faculty.', 'syllabus_id': '75', 'channel_id': '75'}, {'core': false, 'code': '895', 'course_name': 'Doctoral Dissertation Research', 'description': 'Dissertation research', 'syllabus_id': '76', 'channel_id': '76'}, {'core': false, 'code': '896', 'course_name': 'Summer Dissertation Research', 'description': 'For graduate students whose programs of work specify no formal course work during a summer session and who will be devoting full time to thesis research.', 'syllabus_id': '77', 'channel_id': '77'}, {'core': false, 'code': '899', 'course_name': 'Doctoral Dissertation Preparation', 'description': 'For students who have completed all credit hour, full-time enrollment, preliminary examination, and residency requirements for the doctoral degree, and are writing and defending their dissertations.', 'syllabus_id': '78', 'channel_id': '78'}]
)



Schedule.delete_all
Schedule.create!(
  [{'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '11:45', 'course_id': '1', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '1:30', 'course_id': '2', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '8:30', 'course_id': '3', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '10:15', 'course_id': '4', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '6:00', 'course_id': '5', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '3:00', 'course_id': '6', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '3:00', 'course_id': '7', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '1:30', 'course_id': '8', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '2:00', 'course_id': '9', 'day': ['F']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '10:15', 'course_id': '10', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '8:30', 'course_id': '11', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '8:30', 'course_id': '12', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '1:30', 'course_id': '13', 'day': ['F']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '1:30', 'course_id': '14', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '10:40', 'course_id': '15', 'day': ['M', 'W', 'F']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '10:40', 'course_id': '16', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '1:30', 'course_id': '17', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '10:15', 'course_id': '18', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '6:00', 'course_id': '19', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '3:00', 'course_id': '20', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '4:30', 'course_id': '21', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '4:30', 'course_id': '22', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '11:45', 'course_id': '23', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '8:30', 'course_id': '24', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '3:00', 'course_id': '25', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '1:30', 'course_id': '26', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '4:30', 'course_id': '27', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '3:00', 'course_id': '28', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '11:45', 'course_id': '29', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '11:45', 'course_id': '30', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '4:30', 'course_id': '31', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '11:45', 'course_id': '32', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '10:15', 'course_id': '33', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '10:15', 'course_id': '34', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '10:15', 'course_id': '35', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '10:15', 'course_id': '36', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '10:15', 'course_id': '37', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '38', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '39', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '40', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '41', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '42', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '43', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '44', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '45', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '46', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '47', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '48', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': 'TBD', 'course_id': '49', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '50', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '11:45', 'course_id': '51', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '11:45', 'course_id': '52', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '11:45', 'course_id': '53', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '10:15', 'course_id': '54', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '1:30', 'course_id': '55', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '3:00', 'course_id': '56', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '12:50', 'course_id': '57', 'day': ['F']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '12:50', 'course_id': '58', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '1:30', 'course_id': '59', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '1:30', 'course_id': '60', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '1:30', 'course_id': '61', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '11:45', 'course_id': '62', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '11:45', 'course_id': '63', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '6:00', 'course_id': '64', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '3:00', 'course_id': '65', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Fall', 'time': '4:30', 'course_id': '66', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '4:30', 'course_id': '67', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '4:30', 'course_id': '68', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '9:35', 'course_id': '69', 'day': ['M', 'W', 'F']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '10:15', 'course_id': '70', 'day': ['M', 'W']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': '11:45', 'course_id': '71', 'day': ['TU', 'TH']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '72', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '73', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '74', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '75', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '76', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '77', 'day': ['NA']},
  {'ratings': '4', 'fieldwork': true, 'project': true, 'semester': 'Any', 'time': 'TBD', 'course_id': '78', 'day': ['NA']}
])


AverageGrade.delete_all
AverageGrade.create!([{ syllabus_id: '1',
                        A: '20',
                        B: '13',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '2',
                        A: '56',
                        B: '15',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '3',
                        A: '27',
                        B: '8',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '4',
                        A: '9',
                        B: '0',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '5',
                        A: '21',
                        B: '4',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '6',
                        A: '14',
                        B: '9',
                        C: '3',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '7',
                        A: '29',
                        B: '11',
                        C: '3',
                        D: '0',
                        Other: '4' },
                      { syllabus_id: '8',
                        A: '77',
                        B: '6',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '9',
                        A: '33',
                        B: '10',
                        C: '2',
                        D: '1',
                        Other: '4' },
                      { syllabus_id: '10',
                        A: '53',
                        B: '24',
                        C: '4',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '11',
                        A: '49',
                        B: '51',
                        C: '4',
                        D: '2',
                        Other: '0' },
                      { syllabus_id: '12',
                        A: '25',
                        B: '4',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '13',
                        A: '32',
                        B: '8',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '14',
                        A: '12',
                        B: '3',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '15',
                        A: '110',
                        B: '73',
                        C: '9',
                        D: '2',
                        Other: '2' },
                      { syllabus_id: '16',
                        A: '57',
                        B: '50',
                        C: '6',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '17',
                        A: '29',
                        B: '2',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '18',
                        A: '35',
                        B: '13',
                        C: '12',
                        D: '4',
                        Other: '1' },
                      { syllabus_id: '19',
                        A: '15',
                        B: '15',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '20',
                        A: '37',
                        B: '5',
                        C: '2',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '21',
                        A: '3',
                        B: '8',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '22',
                        A: '22',
                        B: '5',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '23',
                        A: '6',
                        B: '3',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '24',
                        A: '9',
                        B: '2',
                        C: '2',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '25',
                        A: '59',
                        B: '1',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '26',
                        A: '9',
                        B: '3',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '27',
                        A: '17',
                        B: '3',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '28',
                        A: '16',
                        B: '8',
                        C: '3',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '29',
                        A: '103',
                        B: '33',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '30',
                        A: '4',
                        B: '3',
                        C: '1',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '31',
                        A: '63',
                        B: '0',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '32',
                        A: '39',
                        B: '1',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '33',
                        A: '7',
                        B: '6',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '34',
                        A: '37',
                        B: '0',
                        C: '0',
                        D: '0',
                        Other: '0' },
                      { syllabus_id: '35',
                        A: '11',
                        B: '5',
                        C: '0',
                        D: '0',
                        Other: '0' }])

StaticWorkload.delete_all
StaticWorkload.create!([{ syllabus_id: '1',
                          core: '01.00',
                          assignments: '01.00',
                          exams: '01.00',
                          project: '02.00' },
                        { syllabus_id: '15',
                          core: '01.00',
                          assignments: '02.00',
                          exams: '02.00',
                          project: '00.00' },
                        { syllabus_id: '9',
                          core: '01.00',
                          assignments: '02.00',
                          exams: '02.00',
                          project: '00.00' },
                        { syllabus_id: '10',
                          core: '00.00',
                          assignments: '02.00',
                          exams: '01.50',
                          project: '00.00' },
                        { syllabus_id: '11',
                          core: '01.00',
                          assignments: '00.50',
                          exams: '01.50',
                          project: '01.50' }])